package com.capitalware.ufm.watch;

import java.util.ArrayList;

import com.capitalware.ufm.action.objects.UFMObject;

/**
 * Abstract Class: FileWatch and DirectoryWatch are extended from this base.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public abstract class Watch
{
   public    ArrayList<UFMObject> actionAL = null;
   protected String              _completePathToTarget;

   /**
    * Initialize Watch
    *
    * @param filename
    *           filename of file or directory to watch
    */
   public Watch(String data)
   {
      this._completePathToTarget = data;
   }

   /**
    * @return path of this watch
    */
   public String getPath()
   {
      return _completePathToTarget;
   }

   /**
    * @return ArrayList representation of changes of this watch
    */
   public abstract ArrayList<String> check();

   /**
    * Output values used.
    */
   public abstract void printValues();

   /**
    * Reset the last modified time stamp
    */
   public abstract void resetLastModified(String filename);
}